"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var bignumber_js_1 = __importDefault(require("bignumber.js"));
var bn = function (val) { return new bignumber_js_1["default"](val); };
function infixToPostfix(exp) {
    var e_1, _a;
    var infix = exp.match(/(\*\*)|[\+\-\*\/\%\(\)]|([0-9]+([\.][0-9]+)?)/g);
    var presedences = ['-', '+', '**', '*', '/', '%'];
    var opsStack = [];
    var postfix = [];
    try {
        for (var infix_1 = __values(infix), infix_1_1 = infix_1.next(); !infix_1_1.done; infix_1_1 = infix_1.next()) {
            var token = infix_1_1.value;
            if (typeof Number(token) === 'number' && isFinite(token)) {
                postfix.push(token);
                continue;
            }
            var topOfStack = opsStack[opsStack.length - 1];
            if (!opsStack.length || topOfStack == '(') {
                opsStack.push(token);
                continue;
            }
            if (token == '(') {
                opsStack.push(token);
                continue;
            }
            if (token == ')') {
                while (opsStack.length) {
                    var op = opsStack.pop();
                    if (op == '(')
                        break;
                    postfix.push(op);
                }
                continue;
            }
            var prevPresedence = presedences.indexOf(topOfStack);
            var currPresedence = presedences.indexOf(token);
            while (currPresedence < prevPresedence) {
                var op = opsStack.pop();
                postfix.push(op);
                prevPresedence = presedences.indexOf(opsStack[opsStack.length - 1]);
            }
            opsStack.push(token);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (infix_1_1 && !infix_1_1.done && (_a = infix_1["return"])) _a.call(infix_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    while (opsStack.length) {
        var op = opsStack.pop();
        if (op == '(')
            break;
        postfix.push(op);
    }
    return postfix;
}
var operatorMap = {
    '+': 'plus',
    '-': 'minus',
    '*': 'times',
    '/': 'div',
    '**': 'pow',
    '%': 'mod'
};
function evaluatePostfixExp(postfix) {
    var e_2, _a;
    try {
        for (var _b = __values(postfix.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), index = _d[0], token = _d[1];
            if (/\+|\-|\*\*|\*|\/|\%/.test(token)) {
                var grainExp = '';
                if (/^[0-9]+([\.][0-9]+)?$/.test(postfix[index - 2])) {
                    grainExp = "bn(" + postfix[index - 2] + ")." + operatorMap[token] + "(" + postfix[index - 1] + ")";
                }
                else {
                    grainExp = postfix[index - 2] + "." + operatorMap[token] + "(" + postfix[index - 1] + ")";
                }
                postfix[index] = grainExp;
                postfix.splice(index - 2, 2);
                if (1 === postfix.length) {
                    break;
                }
                evaluatePostfixExp(postfix);
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b["return"])) _a.call(_b);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return postfix + ".toString()";
}
exports["default"] = (function (exp) { return eval(evaluatePostfixExp(infixToPostfix(exp))); });
//# sourceMappingURL=index.js.map